package com.yc.ship.module.trade.service.smsProduct;

import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.framework.common.util.object.BeanUtils;
import com.yc.ship.module.trade.controller.admin.smsProduct.vo.SmsProductPageReqVO;
import com.yc.ship.module.trade.controller.admin.smsProduct.vo.SmsProductSaveReqVO;
import com.yc.ship.module.trade.dal.dataobject.smsProduct.SmsProductDO;
import com.yc.ship.module.trade.dal.mysql.smsProduct.SmsProductMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static com.yc.ship.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.yc.ship.module.trade.enums.ErrorCodeConstants.SMS_PRODUCT_NOT_EXISTS;


/**
 * 短信发送配置关联 Service 实现类
 *
 * @author 管理员
 */
@Service
@Validated
public class SmsProductServiceImpl implements SmsProductService {

    @Resource
    private SmsProductMapper smsProductMapper;

    @Override
    public Long createSmsProduct(SmsProductSaveReqVO createReqVO) {
        // 插入
        SmsProductDO smsProduct = BeanUtils.toBean(createReqVO, SmsProductDO.class);
        smsProductMapper.insert(smsProduct);
        // 返回
        return smsProduct.getId();
    }

    @Override
    public void updateSmsProduct(SmsProductSaveReqVO updateReqVO) {
        // 校验存在
        validateSmsProductExists(updateReqVO.getId());
        // 更新
        SmsProductDO updateObj = BeanUtils.toBean(updateReqVO, SmsProductDO.class);
        smsProductMapper.updateById(updateObj);
    }

    @Override
    public void deleteSmsProduct(Long id) {
        // 校验存在
        validateSmsProductExists(id);
        // 删除
        smsProductMapper.deleteById(id);
    }

    private void validateSmsProductExists(Long id) {
        if (smsProductMapper.selectById(id) == null) {
            throw exception(SMS_PRODUCT_NOT_EXISTS);
        }
    }

    @Override
    public SmsProductDO getSmsProduct(Long id) {
        return smsProductMapper.selectById(id);
    }

    @Override
    public PageResult<SmsProductDO> getSmsProductPage(SmsProductPageReqVO pageReqVO) {
        return smsProductMapper.selectPage(pageReqVO);
    }

}